﻿using Infragistics.Documents.Excel;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApplication8
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds = CreateData();
            this.ultraTree1.ColumnSetGenerated += UltraTree1_ColumnSetGenerated;
            this.ultraTree1.SetDataBinding(ds, "ParentTable");
            this.ultraTree1.ExpandAll(Infragistics.Win.UltraWinTree.ExpandAllType.Always);
            this.ultraTree1.Override.CellClickAction = Infragistics.Win.UltraWinTree.CellClickAction.EditCell;
            this.ultraTree1.ColumnSettings.AllowCellEdit = Infragistics.Win.UltraWinTree.AllowCellEdit.Full;

            var wb = this.CreateWorkbook();
            this.ultraSpreadsheet1.Workbook = wb;

            //string filename = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "test.xlsx");
            //wb.Save(filename);
            //Process.Start(filename);
        }

        private void UltraTree1_ColumnSetGenerated(object sender, Infragistics.Win.UltraWinTree.ColumnSetGeneratedEventArgs e)
        {
            e.ColumnSet.Columns["decimal 1"].Format = "#,##0.00;(#,##0.00)";
        }

        private DataSet CreateData()
        {
            DataSet ds = new DataSet();
            DataTable parentTable = DummyDataCreator.GetData(3, new Type[] { typeof(string), typeof(decimal),  });
            foreach (DataRow dr in parentTable.Rows)
            {
                int sign = DummyDataCreator.RandomBool() ? 1 : -1;
                dr["decimal 1"] = Math.Round((decimal)dr["decimal 1"], 2) * sign;                

            }
            parentTable.TableName = "ParentTable";

            DataTable childTable = DummyDataCreator.GetData(30, new Type[] { typeof(int), typeof(string), typeof(decimal) });
            childTable.TableName = "childTable";
            childTable.Columns["Int32 1"].ColumnName = "ParentKey";
            foreach (DataRow dr in childTable.Rows)
            {
                dr["ParentKey"] = DummyDataCreator.RandomInt(0, 2);

                int sign = DummyDataCreator.RandomBool() ? 1 : -1;
                dr["decimal 1"] = Math.Round((decimal)dr["decimal 1"], 2) * sign;
            }

            childTable.AcceptChanges();
            ds.Tables.Add(parentTable);
            ds.Tables.Add(childTable);
            ds.Relations.Add(parentTable.Columns["Key"], childTable.Columns["ParentKey"]);
            return ds;
        }

        private Workbook CreateWorkbook()
        {
            DataTable table = DummyDataCreator.GetData(30, new Type[] { typeof(string), typeof(decimal) });
            foreach (DataRow dr in table.Rows)
            {
                int sign = DummyDataCreator.RandomBool() ? 1 : -1;
                dr["decimal 1"] = Math.Round((decimal)dr["decimal 1"], 2) * sign;
            }

            var wb = new Workbook(WorkbookFormat.Excel2007);
            var ws = wb.Worksheets.Add("Sheet1");

            for (int row = 0; row < table.Rows.Count; row++)            
            {
                DataRow dataRow = table.Rows[row];
                for (int col = 0; col < table.Columns.Count; col++)
                {
                    var value = dataRow[col];
                    ws.Rows[row].SetCellValue(col, value);
                }
            }

            ws.Columns[2].CellFormat.FormatString = "0.00_);(0.00)";
            return wb;
        }
    }
}
